#pragma once

namespace JGL {
    enum class Inversion : u8 {
        None = 0,
        Vertical = 1,
        Horizontal = 2,
    };

    inline Inversion operator|(Inversion a, Inversion b) {
        return static_cast<Inversion>(static_cast<int>(a) | static_cast<int>(b));
    }
    inline bool operator&(Inversion a, Inversion b) {
        return (u8)a & (u8)b;
    }
}

namespace JGL {
    enum class Gradient : u8 {
        Vertical = 0,
        Horizontal = 1,
        DiagonalTopLeft = 2,
        DiagonalBottomLeft = 4
    };

    inline Gradient operator|(Gradient a, Gradient b) {
        return static_cast<Gradient>(static_cast<int>(a) | static_cast<int>(b));
    }

    inline bool operator&(Gradient a, Gradient b) {
        return (u8)a & (u8)b;
    }
}